; 

    ;.486                  ; set processor model
    ;.model flat, stdcall  ; 32 bit memory model
    ;option casemap :none  ; case sensitive

    ;include \masm32\include\windows.inc
    ;include \masm32\include\kernel32.inc


; 


RescToFile 		proto :dword,:dword,:dword
RescToMem 		proto :dword,:dword,:dword


.code
ALIGN 4
RescToFile proc uses edi lpPath:DWORD,szSource:DWORD,nRes:dword
local hData:dword
local MemLen :dword
local hRes:dword
local hFile:dword
local bw:dword

       Invoke FindResource,0,nRes,szSource                 ; locate resource offset
				cmp eax,0
       je error
       mov hRes,eax
       Invoke SizeofResource,0,eax
       mov MemLen,eax                                      ; save size
       Invoke LoadResource,0,hRes                          ; load resource
       Invoke LockResource,eax                             ; lock resource
       mov hData,eax                                       ; save handle = ptr to data

       invoke CreateFile,lpPath,GENERIC_WRITE,FILE_SHARE_WRITE,0,   
                           OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
       mov hFile,eax
       invoke WriteFile,hFile,hData,MemLen,addr bw,0
       invoke CloseHandle,hFile
				clc
    ret
error:
				stc
    ret
RescToFile endp

; #########################################################################

RescToMem proc uses ecx resno:dword,resname:dword,pdata:dword
local hRes:dword
local DataLen:dword
local Data:dword

       Invoke FindResource,0,resno,resname ; locate resource offset
				cmp eax,0
       je error
       mov hRes,eax
       Invoke SizeofResource,0,eax
       mov DataLen,eax                 ; save size
       Invoke LoadResource,0,hRes      ; load resource
       Invoke LockResource,eax         ; lock resource
				mov ecx,pdata                   ; save handle = ptr to data
				mov [ecx],eax
				mov eax,DataLen
       clc
				ret

error: stc
				ret

RescToMem endp
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;		end

;